CCLibrary = {}
local PrevMsg
local PrevTime = 0
local CurrentGame


---------------------------------------------------------------------
--functions
---------------------------------------------------------------------

function CCLibrary:CreateDeck(Decks, Jokers)
    local cardarray = {}
    local Num = (52 + Jokers)
    local Total = Num * Decks
    local Deck = 0
    
    for i = 1, Total do
        cardarray[i] = (i - Num * Deck)
        if (i - Num * Deck) == Num then
            Deck = Deck + 1
        end
    end
    --shuffles at the start, as all games will require a shuffle when the
    --deck is created
    CCLibrary:Shuffle(Total, cardarray)
    return cardarray
end

function CCLibrary:Shuffle(NumOfCards, cardarray)
    local r
    local temp
    
    for i = 1, NumOfCards do
        --chooses a roll between 1 and maxnumber
        r = math.random(NumOfCards)
        --swaps arrays around sorting them into a random order
        temp = cardarray[i]
        cardarray[i] = cardarray[r]
        cardarray[r] = temp
    end
end

function CCLibrary:Deal(players, cards)
end

function CCLibrary:IdentifyCard(cardNum)
    local no = 0
    local suit = NULL
    local face = NULL
    local colour = NULL
    
    --makes the card number, 11 is Jack, 12 is Queen, 0 is king
    no = cardNum % 13
    
    --0 is king, and so should be 13
    if no == 0 then
        no = 13
    end
    
    if no > 10 then
        face = TRUE
    end
    
    if cardNum < 14 then
        suit = "S"
        colour = "B"
    elseif cardNum < 27 then
        suit = "C"
        colour = "B"
    elseif cardNum < 40 then
        suit = "H"
        colour = "R"
    elseif cardNum < 53 then
        suit = "D"
        colour = "R"
    else
        --allowing for jokers
        no = -1
    end
         
    return no, suit, face, colour
end

function CCLibrary:ShowCardFace(card, number, suit)
    bg = DealerCard:GetBackdrop()
    bg.bgFile = string.format("Interface\\AddOns\\CCLibrary\\Images\\card%d%s", number, suit)
    frame:SetBackdrop(bg)
    frame:SetBackdropBorderColor(0, 0, 0)
end


--function sets the values of the card to the frameSlot frame.
function CCLibrary:SetCardToFrame(frame, number, colour, suit, frameSlot)
    frameSlot:SetAttribute("card", frame)
    frameSlot:SetAttribute("number", number)
    frameSlot:SetAttribute("colour", colour) 
    frameSlot:SetAttribute("suit", suit) 
end

--function checks for combat and hides when combat starts
function CCLibrary:OnEvent(frame, event)
    if event == "PLAYER_REGEN_ENABLED" then
         --means frame was open before combat
        if showFlag == 1 then
            frame:Show()
        end
    elseif event == "PLAYER_REGEN_DISABLED" then
        frame:Hide()
    --to stop duplicate messages these extra checks have to be made.  This idea has been taken
    --from wowChess addon by Hexarobi
    elseif event == "CHAT_MSG_ADDON" and ((arg2 ~= PrevMsg) or ((GetTime() - PrevTime) > 0.5)) then
        --sets up the PrevMsg
        PrevMsg = arg2
        PrevTime = GetTime()
        --print("incoming message: ", arg1, ", ", arg2)
        --means it is from my addon not another
        if arg1 == "CCBJ" then
            --call BlackJack function
            CCBlackJack:IncomingMessage(arg2, arg3, arg4)
            
        end
    end
end

---------------------------------------------------------------------
--Improved anchor function that stops cards being stretched
---------------------------------------------------------------------
function CCLibrary:anchorTo(cardFrame, relativeTo, xOffset, yOffset)
local v
local h
local points

    if cardFrame:GetRight() > PatienceFrame:GetRight() then
        h = "RIGHT"
    else
        h = "LEFT"
    end
    if cardFrame:GetBottom() < PatienceFrame:GetBottom() then
        v = "BOTTOM"
    else
        v = "TOP"
    end
    
    points = string.format("%s%s", v, h)
    
    --cardFrame:SetPoint("BOTTOMRIGHT", relativeTo, "BOTTOMRIGHT", xOffset, yOffset)
    --cardFrame:SetPoint("TOPLEFT", relativeTo, "TOPLEFT", xOffset, yOffset)
    
    cardFrame:ClearAllPoints()
    cardFrame:SetPoint(points, relativeTo, points, xOffset, yOffset)

end


